package game;

import sk.thenet.plustd.FM;
import sk.thenet.gamestd.bmp.*;

class EEBoss extends Entity {
	public var rx:Int = 0;
	public var ry:Int = 0;
	public var rw:Int = 40;
	public var rh:Int = 48;
	public var phase:Int = 0;
	public var sphase:Int = 0;
	public var hit_ph:Int = 0;
	public var hit_dmg:Int = 100;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_MOB_SMALL;
		super(Entity.ET_MOB_SMALL, nlvl, nphsx);
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		bd.copyPixels(hit_ph != 0 ? ((hit_ph % 4) < 2 ? Assets.aEnemiesHit : Assets.aEnemies) : Assets.aEnemies,
			pe.xp - (rw << 3) - camxi, pe.yp - (rh << 3) - camyi, (rx << 3) + 112, (ry << 3) + 32, rw << 3, rh << 3);
		if (phase == 2 || phase == 3){
			bd.copyPixels(Assets.aEnemies,
				pe.xp - 48 - (phase == 3 ? 96 - (sphase << 1) : sphase << 1) - camxi, pe.yp - 20 - camyi, 200, 136, 8, 64);
		}
	}
	
	override public function tick():Void {
		if (hit_ph > 0) hit_ph--;
		if (lvl.man.pe.xp >= pe.xp - 16 && lvl.man.pe.xp < pe.xp && lvl.man.pe.yp >= pe.yp - 32 && lvl.man.pe.yp < pe.yp){
			lvl.man.hit();
			lvl.man.pe.xp -= 2;
		}
		for (e in lvl.man.bullet_list){
			if (e.pe.xp >= pe.xp - 16 && e.pe.xp < pe.xp && e.pe.yp >= pe.yp - 32 && e.pe.yp < pe.yp){
				e.hit();
				if (hit_ph == 0){
					hit_ph = 16;
					if (hit_dmg > 0) hit_dmg -= 5;
					if (hit_dmg <= 0){
						Assets.sDeath.play();
						pe.remove = true;
						remove = true;
						return;
					}
				}
			}
		}
		
		switch (phase){
			case 0:
			if (sphase < 16){
				rx = 5;
				ry = 0;
			} else {
				rx = 6;
				ry = 13;
			}
			rw = 5;
			rh = 6;
			sphase++;
			if (sphase >= 32){
				if (pe.xp - lvl.man.pe.xp < 160){
					phase = 1 + FM.floor(Math.random() * 4);
				}
				sphase = 0;
			}
			case 1:
			rx = 0 + (sphase % 4 < 2 ? 5 : 0);
			ry = 0;
			rw = 5;
			rh = 6;
			sphase++;
			if (sphase == 26){
				new EEShrool(pe.xp - 8 * 16, pe.yp - 6 * 16, lvl, phsx);
			}
			if (sphase == 28){
				new EEShrool(pe.xp - 6 * 16, pe.yp - 6 * 16, lvl, phsx);
			}
			if (sphase == 30){
				new EEShrool(pe.xp - 10 * 16, pe.yp - 6 * 16, lvl, phsx);
			}
			if (sphase >= 32){
				phase = 0;
				sphase = 0;
			}
			case 2:
			rx = (sphase % 4 < 2 ? 10 : 15);
			if (sphase > 16) rx = 10;
			ry = 0;
			rw = 5;
			rh = 6;
			sphase++;
			if (lvl.man.pe.xp >= pe.xp - 48 - (phase == 3 ? 96 - (sphase << 1) : sphase << 1)
				&& lvl.man.pe.xp < pe.xp - 48 - (phase == 3 ? 96 - (sphase << 1) : sphase << 1) + 8
				&& lvl.man.pe.yp >= pe.yp - 20){
				lvl.man.hit();
			}
			if (sphase >= 48){
				phase = 0;
				sphase = 0;
			}
			case 3:
			rx = (sphase % 4 < 2 ? 15 : 10);
			if (sphase > 16) rx = 15;
			ry = 0;
			rw = 5;
			rh = 6;
			if (sphase == 0) Assets.sEnemyShoot.play();
			sphase++;
			if (lvl.man.pe.xp >= pe.xp - 48 - (phase == 3 ? 96 - (sphase << 1) : sphase << 1)
				&& lvl.man.pe.xp < pe.xp - 48 - (phase == 3 ? 96 - (sphase << 1) : sphase << 1) + 8
				&& lvl.man.pe.yp >= pe.yp - 20){
				lvl.man.hit();
			}
			if (sphase >= 48){
				phase = 0;
				sphase = 0;
			}
			case 4:
			if ((sphase % 32) < 16){
				rx = 5;
				ry = 0;
			} else {
				rx = 6;
				ry = 13;
			}
			rw = 5;
			rh = 6;
			if (sphase == 0) Assets.sEnemyShoot.play();
			sphase++;
			if (sphase >= 96){
				phase = 0;
				sphase = 0;
			}
		}
	}
}