package game;

import sk.thenet.gamestd.bmp.*;

class EEBullet extends Entity {
	public var phase:Int = 0;
	public var player:Bool;
	public var facing:Bool = false;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics, nxv:Int, nyv:Int, nplayer:Bool){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_BULLET;
		super(Entity.ET_BULLET, nlvl, nphsx);
		pe.xv = nxv;
		pe.yv = nyv;
		if (pe.xv < 0) facing = true;
		player = nplayer;
	}
	
	public function hit():Void {
		Assets.sHit.play();
		pe.remove = true;
		remove = true;
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		if (player)
			bd.copyPixels(Assets.aMan, pe.xp - 4 - camxi, pe.yp - 4 - camyi, 40 + ((phase % 32) >> 3) * 8, 32 + (facing ? 0 : 8), 8, 8);
		else
			bd.copyPixels(Assets.aEnemies, pe.xp - 4 - camxi, pe.yp - 4 - camyi, (phase % 2 == 0 ? 8 : 0) + 80, 32, 8, 8);
	}
	
	override public function tick():Void {
		if (!player && lvl.man.pe.xp >= pe.xp - 6 && lvl.man.pe.xp < pe.xp + 6 && lvl.man.pe.yp >= pe.yp - 6 && lvl.man.pe.yp < pe.yp + 6){
			lvl.man.hit();
			pe.remove = true;
			remove = true;
			return;
		}
		phase++;
		if (phase > 30 || pe.colx1 || pe.colx2 || pe.coly1 || pe.coly2){
			Assets.sHit.play();
			pe.remove = true;
			remove = true;
		}
	}
}