package game;

import sk.thenet.gamestd.bmp.*;

class EECrab extends Entity {
	public var rx:Int = 0;
	public var ry:Int = 0;
	public var facing:Bool = false;
	public var phase:Int = 0;
	public var hit_ph:Int = 0;
	public var hit_dmg:Int = 25;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_MOB_SMALL;
		super(Entity.ET_MOB_SMALL, nlvl, nphsx);
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		bd.copyPixels(hit_ph != 0 ? ((hit_ph % 4) < 2 ? Assets.aEnemiesHit : Assets.aEnemies) : Assets.aEnemies,
			pe.xp - 12 - camxi, pe.yp - 8 - camyi, (rx * 24) + 64, ry << 4, 24, 16);
	}
	
	override public function tick():Void {if (hit_ph > 0) hit_ph--;
		if (lvl.man.pe.xp >= pe.xp - 6 && lvl.man.pe.xp < pe.xp + 6 && lvl.man.pe.yp >= pe.yp - 6 && lvl.man.pe.yp < pe.yp + 6){
			lvl.man.hit();
		}
		for (e in lvl.man.bullet_list){
			if (e.pe.xp >= pe.xp - 6 && e.pe.xp < pe.xp + 6 && e.pe.yp >= pe.yp - 6 && e.pe.yp < pe.yp + 6){
				e.hit();
				if (hit_ph == 0){
					hit_ph = 16;
					if (hit_dmg > 0) hit_dmg -= 5;
					if (hit_dmg <= 0){
						Assets.sDeath.play();
						pe.remove = true;
						remove = true;
						return;
					}
				}
			}
		}
		rx = if (phase < 16){
			1;
		} else if (phase >= 16 && phase < 32){
			0;
		} else if (phase >= 32 && phase < 48){
			1;
		} else {
			2;
		}
		if (phase == 33){
			Assets.sEnemyShoot.play();
			new EEBulletBounce(pe.xp, pe.yp, lvl, phsx);
		}
		pe.yv = 1;
		phase++;
		phase %= 128;
	}
}