package game;

import sk.thenet.gamestd.bmp.*;

class EESnail extends Entity {
	public var rx:Int = 0;
	public var ry:Int = 0;
	public var facing:Bool = false;
	public var phase:Int = 0;
	public var hit_ph:Int = 0;
	public var hit_dmg:Int = 15;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_MOB_SMALL;
		super(Entity.ET_MOB_SMALL, nlvl, nphsx);
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		bd.copyPixels(hit_ph != 0 ? ((hit_ph % 4) < 2 ? Assets.aEnemiesHit : Assets.aEnemies) : Assets.aEnemies,
			pe.xp - 8 - camxi, pe.yp - 8 - camyi, (rx << 4) + 32, ry << 4, 16, 16);
	}
	
	override public function tick():Void {
		if (hit_ph > 0) hit_ph--;
		if (lvl.man.pe.xp >= pe.xp - 6 && lvl.man.pe.xp < pe.xp + 6 && lvl.man.pe.yp >= pe.yp - 6 && lvl.man.pe.yp < pe.yp + 6){
			lvl.man.hit();
		}
		for (e in lvl.man.bullet_list){
			if (e.pe.xp >= pe.xp - 6 && e.pe.xp < pe.xp + 6 && e.pe.yp >= pe.yp - 6 && e.pe.yp < pe.yp + 6){
				e.hit();
				if (hit_ph == 0){
					hit_ph = 16;
					if (hit_dmg > 0) hit_dmg -= 5;
					if (hit_dmg <= 0){
						Assets.sDeath.play();
						pe.remove = true;
						remove = true;
						return;
					}
				}
			}
		}
		var nxt:Int = pe.xp >> 4;
		var nyt:Int = pe.yp >> 4;
		var ground:Bool = false;
		if (pe.coly1){
			ground = true;
		}
		if (pe.colx1){
			facing = true;
		}
		if (pe.colx2){
			facing = false;
		}
		pe.yv = 2;
		rx = (phase >= 8 && phase < 16 ? 1 : 0);
		pe.xv = if (ground && phase > 16 && phase <= 20){
			facing ? -1 : 1;
		} else if (ground && phase > 20 && phase <= 28 && phase % 2 == 0){
			facing ? -1 : 1;
		} else {
			pe.xv + (pe.xv < 0 ? 1 : (pe.xv > 0 ? -1 : 0));
		};
		phase++;
		phase %= 32;
		if (facing){
			ry = 1;
		} else {
			ry = 0;
		}
	}
}