package game;

import sk.thenet.plustd.FM;
import sk.thenet.gamestd.bmp.*;

class EManInactive extends Entity {
	public var id:Int;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics, nid:Int){
		id = nid;
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_NONE;
		super(Entity.ET_MAN_INACTIVE, nlvl, nphsx);
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		var pres:Bool = cast(Main.st.cstr, GSGame).pres[id];
		var sel:Bool = cast(Main.st.cstr, GSGame).cmc_sel == id;
		var cmc_phase:Int = !sel ? 60 : (60 - cast(Main.st.cstr, GSGame).cmc_phase);
		var bat:Int = FM.floor((cast(Main.st.cstr, GSGame).battery[id] / GSGame.BAT_MAX) * 21 * (cmc_phase / 60));
		var hp:Int = FM.floor((cast(Main.st.cstr, GSGame).damage[id] / GSGame.HP_MAX) * 21 * (cmc_phase / 60));
		if (!pres && cast(Main.st.cstr, GSGame).control != GSGame.GC_MAN_CHOSEN){
			bat = 0;
			hp = 0;
		}
		bd.fillRect(pe.xp - 3 - camxi, pe.yp - bat - 12 - camyi, 2, 1 + bat, Assets.palette[14 - (sel ? 1 : 0)]);
		bd.fillRect(pe.xp + 1 - camxi, pe.yp - hp - 12 - camyi, 2, 1 + hp, Assets.palette[9 - (sel ? 1 : 0)]);
		if (pres) bd.copyPixels(Assets.aMan, pe.xp - 8 - camxi, pe.yp - 8 - camyi, 48
			+ (sel ? 16 : 0), 16, 16, 16);
	}
}